/**
 * @file codestream.d
 * @brief An text-code stream class, usefull for blocks/indent.
 * @author Sebastien Alaiwan
 * @date 2014-10-09
 */

import std.string;

class CodeStream
{
public:
  void writefln(T...)(T args)
  {
    m_data ~= indentation();
    writef(args);
    m_data ~= "\n";
  }

  override string toString() const
  {
    return m_data;
  }

  void indent()
  {
    ++m_indent;
  }

  void unindent()
  {
    --m_indent;
  }

private:
  string indentation() const
  {
    string s;
    for(int i=0;i < m_indent;++i)
      s ~= "  ";
    return s;
  }

  void writef(T...)(T args)
  {
    m_data ~= format(args);
  }

  string m_data;
  int m_indent;
}

