/**
 * @file exe_test_analyzer.d
 * @brief A test PE analyzer
 * @author Sebastien Alaiwan
 * @date 2014-10-09
 */

/*
 * Copyright (C) 2014 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import std.stdio;
import std.string;
import model;
import analyzer;
import parser_generator;

int main(string[] args)
{
  writeln(getParserCode(getModel()));

  runAnalyzer(getModel(), args);
  return 0;
}

MODEL getModel()
{
  return [
    mkNamedSequence
    (
      "root",
      [
        mkField(1, "int", "a", 1, ""),
        mkField(1, "int", "b", 1, ""),
        mkIf("toto",
             mkSequence
             (
               [
                 mkField(1, "int", "c", 1, ""),
               ]
             ),
             mkSequence
             (
               [
                 mkField(1, "int", "d", 1, ""),
               ]
             )
             ),
      ]
    ),
  ];
}

