/**
 * @file bmp.d
 * @author Sebastien Alaiwan
 * @date 2014-10-08
 */

/*
 * Copyright (C) 2014 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import model;

MODEL Model()
{
  return [
    mkNamedSequence
    (
      "BMP",
      [
        mkField(1, "BITMAPFILEHEADER", "file_header", 1, ""),
        mkField(1, "BITMAPINFOHEADER", "bmp_header", 1, ""),
      ]
    ),
    mkNamedSequence
    (
      "BITMAPFILEHEADER",
      [
        mkField(2, "WORD", "bfType", 1, ""),
        mkField(4, "DWORD", "bfSize", 1, ""),
        mkField(2, "WORD", "bfReserved1", 1, ""),
        mkField(2, "WORD", "bfReserved2", 1, ""),
        mkField(4, "DWORD", "bfOffBits", 1, ""),
      ]
    ),
    mkNamedSequence
    (
      "BITMAPINFOHEADER",
      [
        mkField(4, "DWORD", "biSize", 1, ""),
        mkField(4, "LONG", "biWidth", 1, ""),
        mkField(4, "LONG", "biHeight", 1, ""),
        mkField(2, "WORD", "biPlanes", 1, ""),
        mkField(2, "WORD", "biBitCount", 1, ""),
        mkField(4, "DWORD", "biCompression", 1, ""),
        mkField(4, "DWORD", "biSizeImage", 1, ""),
        mkField(4, "LONG", "biXPelsPerMeter", 1, ""),
        mkField(4, "LONG", "biYPelsPerMeter", 1, ""),
        mkField(4, "DWORD", "biClrUsed", 1, ""),
        mkField(4, "DWORD", "biClrImportant", 1, ""),
      ]
    ),
  ];
}

