import std.stdio;

alias ushort WORD;
alias uint DWORD;
alias int LONG;
alias ubyte BYTE;

class Stream
{
  this(string filename)
  {
    f = File(filename);
  }

  File f;
}

BYTE parse_BYTE(Stream s)
{
  BYTE c[1];
  s.f.rawRead(c);
  return c[0];
}

WORD parse_WORD(Stream s)
{
  BYTE c[2];
  s.f.rawRead(c);
  return (c[1] << 8) + c[0];
}

DWORD parse_DWORD(Stream s)
{
  BYTE c[4];
  s.f.rawRead(c);
  DWORD r = 0;

  for(int i = 0; i < 4; ++i)
    r += c[i] << (8 * i);

  return r;
}

LONG parse_LONG(Stream s)
{
  BYTE c[4];
  s.f.rawRead(c);
  DWORD r = 0;

  for(int i = 0; i < 4; ++i)
    r += c[i] << (8 * i);

  return r;
}

void print_LONG(string name, LONG val, File o)
{
  o.writefln("%s: %s", name, val);
}

void print_DWORD(string name, DWORD val, File o)
{
  o.writefln("%s: 0x%.8X", name, val);
}

void print_WORD(string name, WORD val, File o)
{
  o.writefln("%s: 0x%.4X", name, val);
}

void print_BYTE(string name, BYTE val, File o)
{
  o.writefln("%s: 0x%.2X", name, val);
}

